#KQML_HOME=../..

KQML_BIN = ${KQML_ARCH}/bin
KQML_INCLUDE = -I${KQML_HOME}/include -I$(KQML_ARCH)/include
KQML_LIB = ${KQML_ARCH}/lib

VPATH = $(KQML_HOME)/src/examples

INCLUDES = ${KQML_INCLUDE}
LIBDIRS = -L${KQML_LIB}

STDLIBS = -lsocket -lnsl -lm -lc
LOADLIBES = -lkqml ${STDLIBS}

INSTALL = /usr/sbin/install -m 0755

CC = /usr/local/bin/gcc
CFLAGS = -g -DDEBUG -Wall ${INCLUDES}
LDFLAGS = ${LIBDIRS}

PROGRAMS = server client agent agentls anscheck agentadd agentrm anskill

all: $(PROGRAMS)

server: server.c ${KQML_LIB}/libkqml.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $(VPATH)/server.c $(LOADLIBES)

client: client.c ${KQML_LIB}/libkqml.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $(VPATH)/client.c $(LOADLIBES)

agent: agent.c ${KQML_LIB}/libkqml.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $(VPATH)/agent.c $(LOADLIBES)

agentls: ansutil.c ${KQML_LIB}/libkqml.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $(VPATH)/ansutil.c $(LOADLIBES)

anscheck agentadd agentrm anskill: agentls
	-@rm -f $@
	ln $? $@

install: all
	${INSTALL} -f ${KQML_BIN} server
	${INSTALL} -f ${KQML_BIN} client
	${INSTALL} -f ${KQML_BIN} agent
	${INSTALL} -f ${KQML_BIN} agentls
	-@rm -f ${KQML_BIN}/agentadd ${KQML_BIN}/agentrm 
	-@rm -f ${KQML_BIN}/anskill ${KQML_BIN}/anscheck
	ln ${KQML_BIN}/agentls ${KQML_BIN}/agentadd
	ln ${KQML_BIN}/agentls ${KQML_BIN}/agentrm
	ln ${KQML_BIN}/agentls ${KQML_BIN}/anscheck
	ln ${KQML_BIN}/agentls ${KQML_BIN}/anskill


clean:
	-/bin/rm $(PROGRAMS)

