# This Makefile builds the C KQML Router
# 
# $Log: Makefile,v $
# Revision 1.1  1993/01/25  13:32:03  fritzson
# Initial revision
#
#

KQML_BIN	= ${KQML_ARCH}/bin
KQML_INCLUDE	= -I${KQML_HOME}/include -I$(KQML_ARCH)/include
KQML_LIB	= ${KQML_ARCH}/lib

VPATH = $(KQML_HOME)/src/router

# Gnu
CC 	= /usr/local/bin/gcc

#CFLAGS = -O -Wall ${INCLUDES}
CFLAGS = -g -DDEBUG -Wall ${INCLUDES}
LDFLAGS = ${LIBDIRS}

INCLUDES = -I. ${KQML_INCLUDE}
LIBDIRS = -L${KQML_LIB} -L/usr/local/lib

STDLIBS	= -lsocket -lnsl -lm -lc
LOADLIBES = -lkqml ${STDLIBS}

INSTALL       = /usr/sbin/install -m 0755

SOURCES	       = router.c
OBJECTS	       = router.o timings.o send_pars_msg.o

PROGRAMS       = router


all: ${PROGRAMS}

router:	${OBJECTS} ${KQML_LIB}/libkqml.a
	${CC} ${CFLAGS} ${LDFLAGS} -o $@ ${OBJECTS} ${LOADLIBES}

test: test_router

test_router: test_router.o ${KQML_LIB}/libkqml.a 
	${CC} ${CFLAGS} ${LDFLAGS} -o test_router test_router.o ${LOADLIBES}


install: all
	${INSTALL} -f ${KQML_BIN} router


clean:
	/bin/rm -f ${PROGRAMS} *.h *.o *~ *.BAK



