#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <malloc.h>
#include <ctype.h>

#include <kqml.h>

static char *agentName;

static void *AskIfHandler(char *content, kqml_message *message, 
	KQML_REPLY_TYPE *reply_type);
static void *AskOneHandler(char *content, kqml_message *message,
	KQML_REPLY_TYPE *reply_type);
static void *AskAllHandler(char *content, kqml_message *message,
	KQML_REPLY_TYPE *reply_type);
static void *TellHandler(char *content, kqml_message *message,
	KQML_REPLY_TYPE *reply_type);
static void *UntellHandler(char *content, kqml_message *message,
	KQML_REPLY_TYPE *reply_type);
static void *BrokerHandler(char *content, kqml_message *message,
	KQML_REPLY_TYPE *reply_type);
static void *AdvertiseHandler(char *content, kqml_message *message,
	KQML_REPLY_TYPE *reply_type);
static void *ErrorHandler(char *content, kqml_message *message,
	KQML_REPLY_TYPE *reply_type);

static kqml_message *ReadMessage(char *reciever);
static int StripCR(char *string);
void main(int argc, char *argv[]);

static void *AskIfHandler(char *content, kqml_message *message,
	KQML_REPLY_TYPE *reply_type)
{
	char *receiver;
	kqml_message *kmsg;

	receiver = kqml_get_field (":sender", message, NULL, NULL);
	printf("\n\nALERT. MESSAGE RECEIVED FROM A REMOTE AGENT. ALERT\n\n");
	kqml_print_msg (stdout, message);

	if (kqml_get_field (":reply-with", message, NULL, NULL) == NULL)
	{
		*reply_type = KQML_REPLY_NONE;
		return NULL;
	}

	kmsg = ReadMessage (receiver);
	
	*reply_type = KQML_REPLY_KMSG;
	return kmsg;
}

static void *AskOneHandler(char *content, kqml_message *message,
	KQML_REPLY_TYPE *reply_type)
{
	char *receiver;
	kqml_message *kmsg;

	receiver = kqml_get_field (":sender", message, NULL, NULL);
	printf("\n\nALERT. MESSAGE RECEIVED FROM A REMOTE AGENT. ALERT\n\n");
	kqml_print_msg (stdout, message);

	if (kqml_get_field (":reply-with", message, NULL, NULL) == NULL)
	{
		*reply_type = KQML_REPLY_NONE;
		return NULL;
	}

	kmsg = ReadMessage (receiver);
	
	*reply_type = KQML_REPLY_KMSG;
	return kmsg;
}

static void *AskAllHandler(char *content, kqml_message *message,
	KQML_REPLY_TYPE *reply_type)
{
	char *receiver;
	kqml_message *kmsg;

	receiver = kqml_get_field (":sender", message, NULL, NULL);
	printf("\n\nALERT. MESSAGE RECEIVED FROM A REMOTE AGENT. ALERT\n\n");
	kqml_print_msg (stdout, message);

	if (kqml_get_field (":reply-with", message, NULL, NULL) == NULL)
	{
		*reply_type = KQML_REPLY_NONE;
		return NULL;
	}

	kmsg = ReadMessage (receiver);
	
	*reply_type = KQML_REPLY_KMSG;
	return kmsg;
}

static void *TellHandler(char *content, kqml_message *message,
	KQML_REPLY_TYPE *reply_type)
{
	char *receiver;
	kqml_message *kmsg;

	receiver = kqml_get_field (":sender", message, NULL, NULL);
	printf("\n\nALERT. MESSAGE RECEIVED FROM A REMOTE AGENT. ALERT\n\n");
	kqml_print_msg (stdout, message);

	if (kqml_get_field (":reply-with", message, NULL, NULL) == NULL)
	{
		*reply_type = KQML_REPLY_NONE;
		return NULL;
	}

	kmsg = ReadMessage (receiver);
	
	*reply_type = KQML_REPLY_KMSG;
	return kmsg;
}

static void *UntellHandler(char *content, kqml_message *message,
	KQML_REPLY_TYPE *reply_type)
{
	char *receiver;
	kqml_message *kmsg;

	receiver = kqml_get_field (":sender", message, NULL, NULL);
	printf("\n\nALERT. MESSAGE RECEIVED FROM A REMOTE AGENT. ALERT\n\n");
	kqml_print_msg (stdout, message);

	if (kqml_get_field (":reply-with", message, NULL, NULL) == NULL)
	{
		*reply_type = KQML_REPLY_NONE;
		return NULL;
	}

	kmsg = ReadMessage (receiver);
	
	*reply_type = KQML_REPLY_KMSG;
	return kmsg;
}

static void *AdvertiseHandler (char *content, kqml_message *message,
	KQML_REPLY_TYPE *reply_type)
{
	char *receiver;
	kqml_message *kmsg;

	receiver = kqml_get_field (":sender", message, NULL, NULL);
	printf("\n\nALERT. MESSAGE RECEIVED FROM A REMOTE AGENT. ALERT\n\n");
	kqml_print_msg (stdout, message);

	if (kqml_get_field (":reply-with", message, NULL, NULL) == NULL)
	{
		*reply_type = KQML_REPLY_NONE;
		return NULL;
	}

	kmsg = ReadMessage (receiver);

	*reply_type = KQML_REPLY_KMSG;
	return kmsg;
}

static void *BrokerHandler (char *content, kqml_message *message,
	KQML_REPLY_TYPE *reply_type)
{
	char *receiver;
	kqml_message *kmsg;

	receiver = kqml_get_field (":sender", message, NULL, NULL);
	printf("\n\nALERT. MESSAGE RECEIVED FROM A REMOTE AGENT. ALERT\n\n");
	kqml_print_msg (stdout, message);

	if (kqml_get_field (":reply-with", message, NULL, NULL) == NULL)
	{
		*reply_type = KQML_REPLY_NONE;
		return NULL;
	}

	kmsg = ReadMessage (receiver);
	*reply_type = KQML_REPLY_KMSG;
	return NULL;
}

static void *ErrorHandler(char *content, kqml_message *message,
	KQML_REPLY_TYPE *reply_type)
{
	char *receiver;
	kqml_message *kmsg;

	receiver = kqml_get_field (":sender", message, NULL, NULL);
	printf("\n\nALERT. MESSAGE RECEIVED FROM A REMOTE AGENT. ALERT\n\n");
	kqml_print_msg (stdout, message);

	if (kqml_get_field (":reply-with", message, NULL, NULL) == NULL)
	{
		*reply_type = KQML_REPLY_NONE;
		return NULL;
	}

	kmsg = ReadMessage (receiver);
	
	*reply_type = KQML_REPLY_KMSG;
	return kmsg;
}

static int StripCR(char *string)
{
	int len;
	char *temp;

	len = strlen(string);
	if (string[len-1] == '\n')
	{
		string[len-1] = '\0';
		len--;
	}

	temp = string;
	while (isspace(*temp))
		temp++;

	do
	{
		*(string++) = *temp;
	}
	while (*(temp++));

	return len;
}

static kqml_message *ReadMessage (char *receiver)
{
	kqml_message *msg;
	char perf[256], tag[256], rec_agent[256], content[4096];

	fflush (stdin);
	do
	{
		printf("\nPerformative ?");
		fgets(perf, sizeof (perf), stdin);
		StripCR(perf);
	}
	while (perf[0] == '\0');

	if (! receiver)
	{
		do
		{
			printf ("\nReceiver ?");
			fgets (rec_agent, sizeof (rec_agent), stdin);
			StripCR (rec_agent);
		}
		while (rec_agent[0] == '\0');
		receiver = rec_agent;
	}

	printf("\nReply-with ?");
	fgets(tag, sizeof (tag), stdin);
	StripCR(tag);
			
	printf("\nContent ?");
	fgets(content, sizeof (content), stdin);
	StripCR(content);

	msg = kqml_build_msg (perf, content, receiver, tag, ":sender", 
		kqml_agent_name, NULL);
	if (msg)
	{
		while (1)
		{
			printf ("Parameter ?");
			fgets(tag, sizeof (tag), stdin);
			StripCR(tag);

			if (tag[0] != ':')
			{
				break;
			}
			printf ("Value ?");
			fgets(content, sizeof (content), stdin);
			StripCR(content);

			kqml_put_field (tag, msg, content, -1);
		}
	}

	return msg;
}

void main(int argc, char *argv[])
{
	kqml_message *msg, *replyMsg;

	if (argc != 2)
	{
		fprintf(stderr, "Usage: %s <agentname>\n", argv[0]);
		exit(1);
	}

	agentName = argv[1];

	if (kqml_initialize(argv[1], KQML_NOT_AN_ANS) == -1)
	{
		fprintf(stderr, "kqml_initialize failed\n");
		exit(1);
	}

	printf ("Agent %s is using %s @ %s and is connected to %s ANS\n",
		kqml_agent_name, kqml_protocol, kqml_addr_info, kqml_ans_name);

	if (kqml_register(AskIfHandler, "ask-if", 1) == -1)
	{
		fprintf(stderr,"kqml_register failed for ask-if\n");
		exit(1);
	}

	if (kqml_register(AskOneHandler, "ask-one", 1) == -1)
	{
		fprintf(stderr,"kqml_register failed for ask-one\n");
		exit(1);
	}

	if (kqml_register(AskAllHandler, "ask-all", 1) == -1)
	{
		fprintf(stderr,"kqml_register failed for ask-all\n");
		exit(1);
	}

	if (kqml_register(TellHandler, "tell", 1) == -1)
	{
		fprintf(stderr,"kqml_register failed for tell\n");
		exit(1);
	}

	if (kqml_register(UntellHandler, "untell", 1) == -1)
	{
		fprintf(stderr,"kqml_register failed for untell\n");
		exit(1);
	}

	if ( kqml_register(AdvertiseHandler, "advertise", 1) == -1 )
	{
		fprintf (stderr, "kqml_register failed for advertise\n");
		exit(1);
	}

	if ( kqml_register(BrokerHandler, "broker-one", 1) == -1 )
	{
		fprintf (stderr, "kqml_register failed for broker-one\n");
		exit(1);
	}

	if (kqml_register(ErrorHandler, "error", 1) == -1)
	{
		fprintf(stderr,"kqml_register failed for error\n");
		exit(1);
	}

	while (1)
	{
		msg = ReadMessage (NULL);
		if (msg != NULL)
		{
			replyMsg = NULL;
			if (kqml_send (KQML_SEND_TIMEOUT, msg, &replyMsg) == -1)
			{
				printf("\nkqml_send unsuccessful\n");
			}
			else
			{
				if (replyMsg != NULL)
				{
					printf("Reply is %s\n", 
						kqml_get_field(":content", replyMsg, NULL, NULL));
					kqml_free_msg (replyMsg);
				}
			}
		}
	}

	exit(0);
}
