#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <kqml.h>

void main(int argc, char **argv)
{
	void		*AskIfHandler(void *, kqml_message *, KQML_REPLY_TYPE *);

	kqml_message	*kmsg, *reply;

	char		*ReplyWith = "t";
	char		Receiver[50], Content[512];

	if (argc != 2)
	{
		fprintf (stderr, "USAGE : agentperl <agent-name>.\n");
		exit(1);
	}

	if (kqml_initialize(argv[1], KQML_NOT_AN_ANS) <= -1)
	{
		fprintf (stderr, "Error in kqml_initialize\n");
		exit(1);
	}

	printf ("Agent %s is using %s @ %s and is connected to %s ANS\n",
		kqml_agent_name, kqml_protocol, kqml_addr_info, kqml_ans_name);

	if (kqml_register (AskIfHandler, "ask-if", 1) == -1)
	{
		fprintf (stderr, "Error in registering ask-if Handler\n");
		exit(1);
	}

	sleep(10);

	printf ("Enter the Perl Command : ");
	scanf("%s", Content); 
       /* fgets (Content, 511, stdin); */
	printf ("Content : %s\n", Content);

	printf ("Enter the receiver agent : ");
	scanf ("%s", Receiver); 
       /* fgets(Receiver, 50, stdin); */
	printf ("%s", Receiver);

	kmsg = kqml_build_msg ("ask-if", Content, Receiver, ReplyWith, NULL);
	if (kmsg == NULL)
	{
		fprintf (stderr, "Error : Could not build kqml message\n");
		exit(1);
	}
	kqml_print_msg (stderr, kmsg);

	reply = NULL;
	if ( kqml_send (KQML_SEND_TIMEOUT, kmsg, &reply) == -1)
	{
		fprintf (stderr, "kqml-send unsuccessful\n");
		exit(1);
	}

	printf("\n*************************************************\n");
	if ( reply != NULL )
	{
		printf ("Content : %s\n", kqml_get_field (":content", reply,	
				NULL, NULL));
		kqml_print_msg (stderr, reply);
	}
	printf("\n*************************************************\n");
	kqml_free_msg (kmsg);
	kqml_free_msg (reply);

	fflush(stdin);
	printf ("Enter a char to quit.\n");
	getchar();
}

void *AskIfHandler(void *content, kqml_message *kmsg, 
					KQML_REPLY_TYPE *reply_type)
{
	char		*tempcontent = content;
	kqml_message	*replyMsg;
	FILE				*fp;
	char				replyContent[512];
	char				rep2[512];

	strcpy(replyContent, "perl -e ");
	strcat(replyContent, tempcontent);
	strcat(replyContent, "> out");
	printf ("Content in handler : [%s]\n", replyContent);
	strcpy (tempcontent, replyContent);
	printf ("\n###### Content : [%s]\n", tempcontent);
	system (tempcontent);

	fp = fopen ("out", "r");
	fgets (replyContent, 512, fp);
        fgets (rep2, 512, fp);
	strcat(replyContent,rep2);

	replyMsg = kqml_build_msg ("reply", replyContent, "", "nil", NULL);
	*reply_type = KQML_REPLY_KMSG;

	return (replyMsg);
}

