#include <pwd.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <kqml.h>


char *big_global_string;


void *
query_handler (char *message, kqml_message *kmsg, KQML_REPLY_TYPE *reply_type)
{
  
  fprintf (stderr, "Responding to query; %s\n", (char *) message);
  fflush (stderr);

  *reply_type = KQML_REPLY_STRING;
  return big_global_string;
}


int
main (int argc, char **argv)
{
  int res;
  int f, n;
  

  big_global_string = malloc (100000);
  if (!big_global_string)
    {
      fprintf (stderr, "What! Not enough memory?\n");
      exit (1);
    }
  if ((f = open (argv[1], O_RDONLY, 0)) < 0)
    {
      fprintf (stderr, "What! No file?\n");
      exit (1);
    }
  
  n = read (f, big_global_string, 100000);

  res = kqml_initialize ("sample_server", KQML_NOT_AN_ANS);
  if (res < 0) 
    {
      fprintf (stderr, "init returned %d\n", res);
      exit (-1);
    }
  
  if (kqml_register (query_handler, "ask-one", 1) < 0)
    {
      fprintf (stderr, "Unable to register handler.\n");
      return -1;
    }
  
  while (1)
    {
      sleep (1000);
    }
  exit (1);
}
